<template>
  <ul class="map-layers-list fa-ul">
    <li v-for="l in mapLayers.filter(l => l.category === category)"
        :key="l.id" @click="toggleMapLayers(l.id)">
      <i class="fa-li fa" :class="[isLayerActive(l.id) ? 'fa-check-square' : 'fa-square-o']"></i>
      <span>{{ l.name }}</span>
      <p class="zoom-msg" v-if="(currentZoom < l.minzoom) && isLayerActive(l.id)">
        Veuillez zoomer pour voir cette couche
      </p>
    </li>
  </ul>
</template>

<script lang="ts">
import { defineComponent, computed } from 'vue';
import { useStore } from '@/store';
import VectorLayer from 'ol/layer/Vector';
import VectorSource from 'ol/source/Vector';
import { GeoJSON } from 'ol/format';
import TileWMS from 'ol/source/TileWMS';
import TileLayer from 'ol/layer/Tile';
import { Fill, Stroke, Style } from 'ol/style';
import ImageLayer from 'ol/layer/Image';
import Static from 'ol/source/ImageStatic';

import { alterWmsLayer, hasLayerByTitle, toggleLayerVisibilityByTitle } from './map';
import { MapLayer } from '@/api';
import { colors } from '@/utils/_colors';

export default defineComponent({
  name: 'LayerTree',
  props: ['category'],
  setup: (props) => {
    const store = useStore();

    const category = props.category;

    const isLayerActive = (k: number) => {
      const mapLayer =  store.state.mapLayers.find(layer => layer.id === k)

      return mapLayer !== undefined && mapLayer.visibility;
    };

    const makeAppUrl = (url: string): string => `${window.location.origin}/${url}`;

    const toggleMapLayers = (k: number) => {
      const mapLayer: MapLayer|undefined = store.state.mapLayers.find(layer => layer.id === k);

      if (mapLayer !== undefined && store.state.map) {

        mapLayer.visibility = !mapLayer.visibility;

        if (mapLayer.visibility) {
          store.commit('setSelectedLayer', mapLayer);

          if (hasLayerByTitle(store.state.map, mapLayer.name)) {  // if layer does not exist
            toggleLayerVisibilityByTitle(store.state.map, mapLayer.name);
          } else {
            let layer;
            switch (mapLayer.type) {
              case 'wms':
                layer = new TileLayer({
                  source: new TileWMS({
                    params: {},
                    url: mapLayer.data,
                    crossOrigin: '',
                  }),
                  zIndex: 100,
                });

                if (mapLayer.name === 'pente > 7%') {
                  layer.on('postrender', (event) => {
                    alterWmsLayer(event.context);
                  });
                }
                break;
              case 'geojson':
                layer = new VectorLayer({
                  source: new VectorSource({
                    format: new GeoJSON(),
                    url: makeAppUrl(mapLayer.data)
                  }),
                  style: new Style({
                    fill: new Fill({
                      color: mapLayer.style ? `${mapLayer.style}88` : `${colors.orange}88`,
                    }),
                    stroke: new Stroke({
                      color: mapLayer.style ?? colors.orange,
                      width: 3,
                    }),
                  }),
                  zIndex: 120,
                });
                break;
              case 'raster':
                const imageExtent: number[] = [...mapLayer.data.split('?EXTENT=')[1].split(',')].map(i => parseInt(i));
                layer = new ImageLayer({
                  source: new Static({
                    url: makeAppUrl(mapLayer.data.split('?')[0]),
                    imageExtent: imageExtent
                  }),
                  zIndex: 110,
                });
                break;
            }
            layer.set('title', mapLayer.name);
            layer.set('sidebar', true);
            store.state.map.addLayer(layer);
          }

        } else {
          store.commit('removeLayer', mapLayer);
          toggleLayerVisibilityByTitle(store.state.map, mapLayer.name);
        }
      }
    };

    return {
      isLayerActive,
      category,
      currentZoom: computed(() => store.state.currentZoom),
      mapLayers: computed(() => store.state.mapLayers),
      toggleMapLayers
    }
  }
})
</script>

<style scoped>
.zoom-msg {
  color: #db440a;
}
</style>
